-- (C) Copyright International Business Machines Corporation 23 January
-- 1990.  All Rights Reserved.
--
-- See the file USERAGREEMENT distributed with this software for full
-- terms and conditions of use.

Filter:  using(Standard, Filter) process(Init: FilterIn)
  declare
    Parms: FilterInterface; -- initialization callmessage
    In: PutLineIn; -- input port: requests from client
    Out: PutLineOut; -- output port: bound to putline service
    PutLineCM: PutLineInterface; -- callmessage containing the line
    Prefix: Charstring; -- string to prepend to each output line
  begin
    -- code for process Filter
    
    
    -- initialization
    receive Parms from Init;
    Out := Parms.PutLine;
    Prefix := Parms.Prefix;
    new In;
    connect Parms.ClientPutLine to In;
    return Parms;
    
    -- main loop
    while ('true') repeat
      receive PutLineCM from In;
      call Out(Prefix | ": " | PutLineCM.Line);
      return PutLineCM;
    end while;
    
  end process
  
